<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\tenant;


use app\common\model\tenant\TenantRatingCommission;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * TenantRatingCommission逻辑
 * Class TenantRatingCommissionLogic
 * @package app\adminapi\logic
 */
class TenantRatingCommissionLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/02/26 18:03
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            $info = TenantRatingCommission::where('tenant_id',$params['tenant_id'])->findOrEmpty();
            if(!$info->isEmpty()){
                throw new \Exception('该租户已存在抽点配置');
            }
            TenantRatingCommission::where('tenant_id',$params['tenant_id'])->delete();
            foreach ($params['allCommission'] as $value) {
                TenantRatingCommission::create([
                    'rating_start' => $value['rating_start'],
                    'rating_end' => $value['rating_end'],
                    'commission' => $value['commission'],
                    'tenant_id' => $params['tenant_id']
                ]);
            }

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/02/26 18:03
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            TenantRatingCommission::where('tenant_id',$params['tenant_id'])->delete();
            foreach ($params['allCommission'] as $value) {
                TenantRatingCommission::create([
                    'rating_start' => $value['rating_start'],
                    'rating_end' => $value['rating_end'],
                    'commission' => $value['commission'],
                    'tenant_id' => $params['tenant_id']
                ]);
            }
            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/02/26 18:03
     */
    public static function delete(array $params): bool
    {
        return TenantRatingCommission::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2025/02/26 18:03
     */
    public static function detail($params): array
    {
        return TenantRatingCommission::findOrEmpty($params['id'])->toArray();
    }
}